//MarginalSpalte_202d.js
// 16.04.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Spalte(n) nach Wunsch, der Restraum wird auf die anderen aufgeteilt

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

var curDoc = app.documents[0];

// die horizontle Masseinheit speichern
// wenn nicht 2053991795 (= Millimeter), auf Millimeter umstellen
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}

// weitere Variablen initialisieren
var curPage = app.activeWindow.activePage;
var leftChk = true;
var rghtChk = true;
var pWidth = curDoc.documentPreferences.pageWidth;
pWidth = Math.floor((pWidth * 1000) + 0.5) / 1000;
var curSpr = app.activeWindow.activeSpread;
var noMarginal = false;
var tC = "1";

// Rnder links und rechts
var pM = new Array (curPage.marginPreferences.left, curPage.marginPreferences.right);
// die Anzahl Spalten
var nC = curPage.marginPreferences.columnCount;
// die Liste der Spaltenlinien
var curPos = curPage.marginPreferences.columnsPositions;
var nPos = curPos.length;
// die Werte linker und rechter Abstand
var leftOff = pt2mm(curPos[0]);
var leftOff2 = pt2mm(curPos[1]);
var lastPos = pt2mm(curPos[nPos-1]);
lastPos = Math.floor((lastPos * 1000) + 0.5) / 1000;
var rghtOff = (pWidth-pM[0]-pM[1])-lastPos;
rghtOff = Math.floor((rghtOff * 1000) + 0.5) / 1000;

// Checkboxen deaktivieren, wenn Position grsser als Rand
if (pM[0] < (pM[0]+leftOff)) {
	leftChk = false;
}
if (pM[0] > (pM[0]+leftOff2)) {
	leftChk = false;
}
if (pM[1] < (pM[1]+rghtOff)) {
	rghtChk = false;
}

if (nPos == 2) {
	// der aktuelle Wert des Steges
	var cG = curPage.marginPreferences.columnGutter;
	// eine Vorgabe-Breite der Marginalspalte
	var mWidth = "23";
}
else {
	// der aktuelle Wert des Steges
	var cG = curPos[2]-curPos[1];
	cG = pt2mm(cG);
	// versuchen, Breite und Position der Marginalspalte festzustellen
	var mWidth = 9999;
	var curVal;
	for (var i=1; i<nPos; i=i+2) {
		curVal = curPos[i]-curPos[i-1];
		curVal = Math.floor((curVal * 1000) + 0.5) / 1000;
		if (curVal < mWidth) {
			mWidth = curVal;
			tC = "" + (Math.floor((i-1) / 2) + 1);
		}
	}
	if (mWidth != 9999) {
		tmpWidth = pt2mm(mWidth);
		tmpWidth = Math.floor((tmpWidth * 1000) + 0.5) / 1000;
		mWidth = "" + tmpWidth;
	}
	else {
		mWidth = "23";
		tC = "1";
	}
	if (tC == "1") {
		if (leftChk) {
			if (leftOff2 > 0) {
				mWidth = "" + ((mWidth*1) + leftOff);
			}
		}
	}
	if ((tC*1) == nC) {
		if (rghtChk) {
			mWidth = "" + ((mWidth*1) + rghtOff);
		}
	}
}

var curName = curPage.name;
var curParent = curPage.parent;

var isMaster = false;
if (curParent == "[object MasterSpread]") {
	isMaster = true;
}

var masNameList = new Array ();
var masPageList = new Array ();
masSpreads = curDoc.masterSpreads;
var nSpreads = masSpreads.length;
for (var s=0; s<nSpreads; s++) {
	masNameList.push(masSpreads[s].pages[0].name);
	nPag = masSpreads[s].pages.length;
	for (var p=0; p<nPag; p++) {
		actPage = masSpreads[s].pages[p].name + "" + (p+1);
		masPageList.push(actPage);
	}
}

// den Dialog vorbereiten
var docList = curDoc.pages.everyItem().name;
var pageList = masPageList.concat(docList);
var propPage = -1;
var targetPage;
if (isMaster) {
	targetPage = (curSpr.pages.item(-1).name) + 1;
	for (var i=0; i<masPageList.length; i++) {
		if (masPageList[i] == targetPage) {
			propPage = i;
			break;
		}
		if (propPage == -1) {
			propPage = 0;
		}
	}
}
else {
	targetPage = curName;
	for (var i=0; i<pageList.length; i++) {
		if (pageList[i] == targetPage) {
			propPage = i;
			break;
		}
	}
		if (propPage == -1) {
		propPage = 0;
	}
}

// Dialoge lschen, welche offengeblieben sind
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}
var labelWidth = 120; 
var aDialog = app.dialogs.add({name:"Spalten nach Wunsch"});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Zielseite", minWidth:labelWidth});
			var pageNames = dropdowns.add({stringList:pageList, selectedIndex:propPage});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl Spalten", minWidth:labelWidth});
					var columnNumberField = integerEditboxes.add({editValue:nC, minWidth:48});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Steg", minWidth:labelWidth});
					var columnGutterField = realEditboxes.add({editValue:cG, minWidth:48});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" ", minWidth:32});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Abstand links", minWidth:labelWidth});
					var leftOffsetField = realEditboxes.add({editValue:leftOff, minWidth:48});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" ", minWidth:32});
				}
				with (dialogRows.add()) {
					var leftMarg = checkboxControls.add({staticLabel:"Erste Spalte beginnt am Satzspiegel", checkedState:leftChk});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Abstand rechts", minWidth:labelWidth});
					var rightOffsetField = realEditboxes.add({editValue:rghtOff, minWidth:48});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" ", minWidth:32});
				}
				var rghtMarg = checkboxControls.add({staticLabel:"Letzte Spalte endet am Satzspiegel", checkedState:rghtChk});
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Marginal-Spalte(n) ..."});
					staticTexts.add({staticLabel:" "});
				}
				with (dialogRows.add()) {
					var marginalWidthField = textEditboxes.add({editContents:mWidth, minWidth:200});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" ", minWidth:4});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"... als Spalte(n) Nr.", minWidth:labelWidth});
					var targetColumnField = textEditboxes.add({editContents:tC, minWidth:75});
				}
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:" ", minWidth:4});
	}
}
// den Dialog anzeigen und auswerten
var dResult = aDialog.show();
var targetMaster = false;
if (dResult == true) {
	var selPage = pageNames.selectedIndex;
	if ((selPage + 1) <= masPageList.length) {
		masNamePg = pageList[selPage];
		targetMaster = true;
	}
	else {
		selPage = selPage - masPageList.length;
	}
	var nCol = (columnNumberField.editValue)*1;
	var cGutter = columnGutterField.editValue;
	leftOff = leftOffsetField.editValue;
	var begFirst = leftMarg.checkedState;
	rghtOff = rightOffsetField.editValue;
	var endLast = rghtMarg.checkedState;
	var margVals = marginalWidthField.editContents;
	var tCol = targetColumnField.editContents;
}
else {
	aDialog.destroy();
	reStore();
	exit();
}
aDialog.destroy();

// ein paar Ergebnisse prfen
if (nCol < 2) {
	alert ("Mindestens zwei Spalten.", "Stop");
	reStore();
	exit();
}
else {
	nC = nCol;
}
if ((pM[0] + leftOff) < 0) {
	alert ("\"Abstand links\" ist zu klein.", "Stop");
	reStore();
	exit();
}
if ((pM[1] + rghtOff) < 0) {
	alert ("\"Abstand rechts\" ist zu klein.", "Stop");
	reStore();
	exit();
}
// die Marginal-Spalten-Eingabe untersuchen
if (margVals != "") {
	// berflssige Zwischenrume entfernen
	margVals = stripSpaces(margVals);
	// unerlaubte Zeichen aufspren
	var nChars = margVals.length;
	var curChar;
	for (var i=0; i<nChars; i++) {
		curChar = margVals[i];
		if ("0123456789,. ".indexOf(curChar) == -1) {
			alert ("Die Marginal-Spalten-Eingabe enthlt das unerlaubte Zeichen '" + curChar + "'", "Stop");
			reStore();
			exit();
		}
	}
	margVals = margVals.split(" ");
	var nMarg = margVals.length;
}
else {
	noMarginal = true;
	nMarg = 0;
}

// die Ziel-Spalten-Eingabe untersuchen
if (tCol != "") {
	// berflssige Zwischenrume entfernen
	tC = stripSpaces(tCol);
	// unerlaubte Zeichen aufspren
	tChars = tC.length;
	var curChar;
	for (var i=0; i<tChars; i++) {
		curChar = tC[i];
		if ("0123456789 ".indexOf(curChar) == -1) {
			alert ("Die Spalten-Nr.-Eingabe enthlt das unerlaubte Zeichen '" + curChar + "'", "Stop");
			reStore();
			exit();
		}
	}
	tC = tC.split(" ");
	var curItem;
	var oldColumn = 0;
	var nNbrs = tC.length;
	for (var i=0; i<nNbrs; i++) {
		curItem = tC[i]*1;
		if (curItem == 0) {
			alert ("Die Spalten-Nummer *Null* gibt es nicht.\n\nEingabe: " + tCol, "Stop");
			reStore();
			exit();
		}
		if (curItem == oldColumn) {
			alert ("Eine Spalten-Nummer kann nur *einmal* zugewiesen werden.\n\nEingabe: " + tCol, "Stop");
			reStore();
			exit();
		}
		else if (curItem < oldColumn) {
			alert ("Die Spalten-Nummern *aufsteigend* eintragen.\n\nEingabe: " + tCol, "Stop");
			reStore();
			exit();
		}
		else if (curItem > oldColumn) {
			oldColumn = curItem;
		}
	}
	if (nMarg != 0) {
		if (nMarg != nNbrs) {
			alert ("Die Anzahl Spaltenwerte und Zielspalten mssen bereinstimmen.\n\nEingaben: Spaltenwerte = " + nMarg + ", Zielspalten = " + nNbrs, "Stop");
			reStore();
			exit();
		}
		if (tC[nNbrs-1]*1 > nC) {
			alert ("Zielspalten-Nummer ist grsser als Anzahl Spalten.\n\nEingaben: Anzahl Spalten = " + nC + ", Zielspalten-Nummer = " + tC[nNbrs-1], "Stop");
			reStore();
			exit();
		}
	}
	else {
		tC = 0;
		var nNbrs = 0;
	}
}
else {
	tC = 0;
	var nNbrs = 0;
	if (noMarginal == false) {
		alert ("Das Feld *... als Spalte(n) Nr.* ist leer.", "Stop");
		reStore();
		exit();
	}
}

// wenn Master als Ziel, den Namen und die Ziffer speichern
if (targetMaster) {
	var masName = masNamePg.slice(0,-1);
	var masPage = (masNamePg.slice(-1)*1)-1;
	var masInd = 0;
	var nMas = masNameList.length;
	for (var m=0; m<nMas; m++) {
		if (masName == masNameList[m]) {
			masInd = m;
			break;
		}
	}
}

// die Werte der Marginal-Spalten zusammenzhlen
var totMarginal = 0;
if (nMarg > 0) {
	for (var m=0; m<nMarg; m++) {
		totMarginal = totMarginal + (margVals[m])*1;
	}
}

// die Breite einer der restlichen Spalten ausrechnen
var nG = nC-1;
var cWidth = (pWidth - pM[0] - pM[1] - totMarginal) - (nG * cGutter);
if (begFirst == true && endLast == true) {
	cWidth = cWidth / (nC - nNbrs);
}
else if (begFirst == false && endLast == false) {
	cWidth = (cWidth - leftOff - rghtOff) / (nC - nNbrs);
}
else if (begFirst == true && endLast == false) {
	cWidth = (cWidth - rghtOff) / (nC - nNbrs);
}
else if (begFirst == false && endLast == true) {
	cWidth = (cWidth - leftOff) / (nC - nNbrs);
}
if (cWidth < 4.233) {
	alert ("Anzahl Spalten oder Steg zu gross.", "Stop");
	reStore();
	exit();
}

// wenn die gewnschte und die vorhandene Anzahl Spalten nicht bereinstimmen
if (targetMaster) {
	curDoc.masterSpreads[masInd].pages.item(masPage).marginPreferences.columnCount = nC;
}
else {
	curDoc.pages[selPage].marginPreferences.columnCount = nC;
}

// den Steg zuweisen
if (cGutter != cG) {
	if (targetMaster) {
		curDoc.masterSpreads[masInd].pages.item(masPage).marginPreferences.columnGutter = cGutter;
	}
	else {
		curDoc.pages[selPage].marginPreferences.columnGutter = cGutter;
	}
}

// die Werte in Punkte umrechnen lassen
var cG = mm2pt(cGutter);
var leftOff = mm2pt(leftOff);
var rghtOff = mm2pt(rghtOff);
var mX = mm2pt(pM[0]+pM[1]);
var pW = mm2pt(pWidth);
var cW = mm2pt(cWidth);

// die Position der ersten Linie
var posA = leftOff;
// die Position der letzten Linie
var posZ = (pW - mX) - rghtOff;
if (begFirst == true) {
	var gPos = (posA - leftOff);
}
else {
	var gPos = posA;
}
var ctr = 0;
var curVal;
var posList = new Array();
posList.push(posA);
// eine Schleife, um die Werte zusammenzustellen
for (var n=1; n<nC; n++) {
	if (n == tC[ctr]*1) {
		curVal = margVals[ctr];
		mW = mm2pt(curVal*1);
		gPos = gPos + mW;
		ctr++;
	}
	else {
		gPos = gPos + cW;
	}
	posList.push(gPos);
	gPos = gPos + cG;
	posList.push(gPos);
}
posList.push(posZ);

// die Spaltenhilfslinien positionieren
if (targetMaster) {
	curDoc.masterSpreads[masInd].pages.item(masPage).marginPreferences.columnsPositions = posList;
}
else {
	curDoc.pages[selPage].marginPreferences.columnsPositions = posList;
}
reStore();

// die Funktionen zum Umrechnen der Werte
function pt2mm(aValue) {
	var ptVal = UnitValue(aValue, "pt");
	return ptVal.as("mm");
}

function mm2pt(aValue) {
	var mmVal = UnitValue(aValue, "mm");
	return mmVal.as("pt");
}

// die Funktion, welche berflssige Leerschlge entfernt (mehrfache, zu Beginn, am Ende)
function stripSpaces(str) {
	return str.replace(/\s+\s/g, ' ').replace(/^\s+/g, '').replace(/\s+$/g, '');
}

// Masseinheite zurcksetzen (falls notwendig)
function reStore() {
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
}